Option Explicit

public const uiVendorClose  = 1
public const uiChatMaximize = 2
public const uiItemTab      = 3
public const uiBuyingTab    = 4
public const uiSellingTab   = 5
public const uiBtnSellAll   = 6
public const uiBtnBuyAll    = 6
public const uiBtnAddToList = 6
public const uiBtnSellItem  = 7
public const uiBtnBuyItem   = 7
public const uiCatDropDown  = 8
public const uiSplitTextbox = 9
public const uiCloseButton  = 10 
public const uiYesToQuit	= 11
public const uiPanelSocial  = 12
public const uiPanelSpells  = 13
public const uiPanelSkills  = 14
public const uiPanelMap		= 15
public const uiPanelOptions = 16
public const uiSocialAllegiance = 17
public const uiSocialFellowship = 18
public const uiSocialTrade		= 19
public const uiFellowNameEntry  = 20
public const uiFellowAcceptReq  = 21
public const uiFellowShareXp	= 22
public const uiFellowShareLoot  = 23
public const uiFellowCreateBtn  = 24
public const uiFellowRecruitBtn  = 25
public const uiFellowDismissBtn  = 26
public const uiFellowDisbandBtn  = 27
public const uiShowInventory = 28
public const uiExamine = 29
public const uiUSTSalvageButton = 30
public const uiUSTSalvageArea = 31
public const uiInventoryTopLeft = 32
public const uiPaperDollCenter = 33
public const uiHotSlotOne = 34
public const uiInventoryPackZero = 35
public const uiVendorSlotZero = 36
' functions to test pixels
'
' Premise:  The line of pixes between 702,679 and 711,679 (-321,-89 to -314,-89)
' will be one color in chat-minimized mode, and have a greater variance in maximized
' mode.
'
public function TestChatSize
dim tAvg, c, i, f, b

 b = false
 for i = -321 to -314
  c = skapi.clrPixel(i,-89)
  if i = -321 then f = c
  tAvg = tAvg + c
 next

 tAvg = tAvg \ 8

 if tAvg=f then b = true
 TestChatSize = b
end function

public sub MaximizeChat()
 ' got frustrated with pixel tests, just have the mouse click the maximize
 ' button *grin* its quick and painless
 SelectUIItem uiChatMaximize
end sub

' with tests for cateogry selection recommeneded by greg (skunkworks author)
public sub SelectVendorCategory(nCat)
dim xpt, ypt, ix, i, xres, chatwin, b, x, a
	
	b = false
    chatwin = -1 * (66 + round(skApi.dypRes/4))
    xres = skApi.dxpRes
	xpt = 60 - xres
	ypt = chatwin - 50

	ix = nCat - 1 ' We already have position for category one
	
	for i = 1 to ix
	 ypt = ypt + 18 ' move down one row
	next
	
	do until b 
	 SelectUIItem uiItemTab
	 SelectUIItem uiCatDropDown


	 set x = skapi.timernew()
	 'if not(skapi.acoselected is nothing) then
	 ' ssay "Before reset " &  skapi.acoselected.szname
	 'end if
	 a = 0
	 skapi.selectaco alem 
	 do
	  Wait cEventWait
	  if a>2 then
		skapi.selectaco alem 
		a = 0
	  else
	   a = a + 1
	  end if
	 loop until (skapi.acoselected is alem) or (x.cmsec>1200)

	 'if not(skapi.acoselected is nothing) then
	 ' ssay "After reset " & skapi.acoselected.szname
	 'end if	 
	 
	 if x.cmsec>1200 then ssay "timeout selecting alembic to reset selection."
	
	 Mouse xpt, ypt
	 Click
	
	 'ssay "changed to (1) " & skapi.acoselected.szname
	 
	 set x = skapi.timernew()
	 SelectUIItem uiVendorSlotZero
	 do
	  Wait cEventWait
	 loop until not(skapi.acoselected is alem) or (x.cmsec>1200)
	 'ssay "changed to (2) " & skapi.acoselected.szname
	 b = x.cmsec<1201
	 if not(b) then
	    ssay "timeout waiting for alembic to be unselected. should be retrying."
	    skapi.selectaco( skApi.AcoFindInInv("Prismatic Taper") )
	    skapi.waitevent cEventWait
	 end if

	
	loop
end sub

sub Drag(code_from,code_to)
dim t
  't= waitforaction
  'WaitForAction= 0
  SelectUIITem_ code_from
  skapi.MouseButton ibuttonLeft,kmoDown 
  SelectUIItem_ code_to
  skapi.MouseButton ibuttonLeft,kmoUp 
  'WaitForAction = t
end sub

public sub SplitSelected_(nCount)
dim aco

	set aco = skapi.acoSelected
	if aco is nothing then exit sub

	SelectUIItem uiSplitTextBox
	skapi.pastesz nCount
	skapi.keys "{Return}"

end sub

Public Sub SplitSelected(nCount)

 SplitSelected_ nCount

' now take the newly split item and move it to the main pack
' which actually performs the split and adds an object to the inventory
' even though the action being taken is a move :)
	hndlr.Expecteditem = aco.szname
	aco.movetopack(0)
     do 
      Wait cEventWait
     loop until hndlr.Added
end sub

Public Sub GiveSelected(nVendor) 'nVendor = aco of the vendor to give to
dim aco
	set aco = skapi.acoSelected
	if aco is nothing then exit sub
	
	skapi.selectaco nVendor
	do until (skapi.acoselected is nvendor)
	 Wait cEventWait
	loop
	skapi.keys cmidGiveSelected
   if WaitForAction>0 then skApi.Waitevent WaitForAction,wemFullTimeOut
end sub

' with changes as recommended by 'mrBlah' (skunkworks forum 8/28/02)
Public Sub SelectUIItem(nItem)
 SelectUIItem_ nItem
 Click
end sub 

Public Sub SelectUIItem_(nItem)
dim xpt, ypt, chatwin, xres

 'pSay skapi.dypres
 chatwin = -1 * (66 + round(skApi.dypRes/4))
 xres = skApi.dxpRes
 select case nItem
    case uiVendorClose:
               xpt = -318
               ypt = (-93 +chatwin)
    case uiChatMaximize:
               xpt = -318
               ypt = -90
    case uiItemTab:
               xpt = 50
               ypt = (-93 +chatwin)
    case uiBuyingTab:
               xpt = 140
               ypt = (-93 +chatwin)
    case uiSellingTab:
                   xpt = 230
               ypt = (-93 +chatwin)
    case uiBtnSellAll, uiBtnBuyAll, uiBtnAddToList:
                   xpt = -340
               ypt = (-38 +chatwin)
    case uiBtnSellItem, uiBtnBuyItem:
                   xpt = -340
               ypt = (-68 +chatwin)
     case uiCatDropDown:
               xpt = 115
               ypt = (-71 +chatwin)
     case uiSplitTextbox:
               xpt = -207
               ypt = -56
     case uiCloseButton:
               xpt = -10
               ypt = 14
     case uiYesToQuit:
               xpt = -218
               ypt = -121
     case uiPanelSocial:
			   xpt = -230
			   ypt = -77
     Case uiPanelSpells:
			   xpt = -196
			   ypt = -77
     Case uiPanelSkills:
			   xpt = -165
			   ypt = -77
     Case uiPanelMap:
			   xpt = -131
			   ypt = -77
     Case uiPanelOptions:
			   xpt = -94
			   ypt = -77
     Case uiSocialAllegiance:
			   xpt = -260
			   ypt = -437
     Case uiSocialFellowship:
			   xpt = -161
			   ypt = -437
     Case uiSocialTrade:
			   xpt = -68
			   ypt = -437
     Case uiFellowNameEntry:
			   xpt = -145
			   ypt = -210
	 Case uiFellowAcceptReq:
			   xpt = -268
			   ypt = -192
     Case uiFellowShareXp:
			   xpt = -268
			   ypt = -176
     Case uiFellowShareLoot:
			   xpt = -268
			   ypt = -158
     Case uiFellowCreateBtn:
			   xpt = -230
			   ypt = -111
     Case uiFellowRecruitBtn:
			   xpt = -248
			   ypt = -109
     Case uiFellowDismissBtn:
			   xpt = -154
			   ypt = -109
     Case uiFellowDisbandBtn:
			   xpt = -66
			   ypt = -109
     Case uiShowInventory:
			   xpt = -27
			   ypt = -62
     Case uiExamine:
			   xpt = -74
			   ypt = -50
	 case uiUSTSalvageButton:
				xpt = -359
				ypt = -299
	 case uiUSTSalvageArea:
				xpt = -528
				ypt = -307
	 case uiInventoryTopLeft:
				xpt = -267
				ypt = -176
	 case uiPaperDollCenter:
				xpt = -208
				ypt = -348
	 case uiHotSlotOne:
				xpt = -283
				ypt = -15
	 case uiInventoryPackZero:
				xpt = -36
				ypt = -390
	 case uiVendorSlotZero:
				xpt = -620
				ypt = -218
 end select

 'psay (xpt - xres) & ", " & (ypt + chatwin) & ":" & nItem
 Mouse xpt , ypt ' allow for the size of the chatwindow in our positioning
                                   ' thanks greg!
 if WaitForAction>0 then skApi.Waitevent WaitForAction,wemFullTimeOut
 
end sub 